Index: /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java
===================================================================
--- /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java	(revision 8970)
+++ /trunk/gli/src/org/greenstone/gatherer/gems/GEMS.java	(revision 8971)
@@ -2736,5 +1963,4 @@
                 }
             }
-            
             return flag;
         }
@@ -2761,5 +1987,5 @@
 			    //Hide the set that are about to rename
 			    mds_tree.clearSelection();
-			    model.remove(current_set.toString(), GEMSNode.SET);
+			    model.remove(current_node);
 
 			    //Rename set & namespace
@@ -2809,71 +2035,10 @@
     }
 
-    /**
-       Class to handle renaming of a subelement
-
-       Author: Matthew Whyte
-       Date last modified: 18/01/05
-     */
-    private class RenameSubelementActionListener extends RenameElementActionListener implements ActionListener {
-	
-	/**
-	   Any implementation of ActionListener must include this method so that we can be informed when an action has occured.
-	   @param event An <string>ActionEvent</strong> containing information about the event.
-	*/
-	public void actionPerformed(ActionEvent event)
-	{
-	    Object source = event.getSource();
-
-	    if(source == ok_button)
-		{
-		    TreeNode selPath = current_node.getParent();
-		    GEMSNode parent = (GEMSNode)selPath;
-		    current_element = parent.getElement();
-		    //MetadataSet currentSet = msm.getSet(current_subelement.getNamespace());
-		    String name_str = Codec.transform(Codec.transformUnicode(name_field.getText()), Codec.TEXT_TO_DOM);
-
-			if(!current_element.containsSubelement(name_str)) //Hopefully this works!
-			    {   
-				//Hide the element that are about to rename
-				mds_tree.clearSelection();
-				model.remove(current_node);
-				
-				msm.renameElement(current_subelement, name_str); //rename the element
-				model.add(parent, current_subelement, GEMSNode.SUBELEMENT);
-
-				//Finish up
-				ignore = false;    
-				atLeastOneSetChanged = true;
-				setVisible(false);
-			    }
-		    
-		    // Otherwise show an error message and do not proceed.
-			else
-			    {
-				JOptionPane.showMessageDialog(self, Dictionary.get("GEMS.Subelement_Already_Exists"), Dictionary.get("General.Error"), JOptionPane.ERROR_MESSAGE);
-			    }
-
-		    name_str = null;
-		}
-	    
-	    else if(source == cancel_button)
-		{
-		    setVisible(false); //hide dialog
-		}
-	    else
-		{
-		    Dictionary.setText(this, "GEMS.Popup.menuRenameSubelement"); //Set title of dialog
-		    name_field.setText(current_subelement.getNameOnly()); //show old name
-		    setVisible(true); //Show the dialog
-		}
-		    
-	    source = null;
-	}
-    }
+   
 
  /**
        Class to handle renaming of an element.
 
-       Author: Matthew Whyte
+       @author: Matthew Whyte
        Date last modified: 10/01/05
     */
@@ -2970,31 +2135,20 @@
 		    TreeNode selPath = current_node.getParent();
 		    GEMSNode parent = (GEMSNode)selPath;
-		    GEMSNode new_node = null;
 		    MetadataSet currentSet = msm.getSet(current_element.getNamespace());
 		    String name_str = Codec.transform(Codec.transformUnicode(name_field.getText()), Codec.TEXT_TO_DOM);
-		    GValueModel value_model = msm.getValueTree(current_element);
-  
+		    GEMSNode new_node = null;
+
 		    // If this element doesn't already exist.
 		    if(!currentSet.containsElement(name_str)) //Do the renaming!
 			{   
-			    //Hide the element that are about to rename
-			    //mds_tree.clearSelection();
-			    model.remove(current_element.getName(), GEMSNode.ELEMENT);
+			    model.remove(current_node); //Hide the element that are about to rename
+			    msm.renameElement(current_element, name_str); //rename the element
+			    //Add the new element
+			    new_node = model.add(parent, current_element, GEMSNode.ELEMENT);
 			    
-			    msm.renameElement(current_element, name_str); //rename the element
+			    //mds_tree.setSelectionPath(new_node_path); //would like to do this but doesn't hilight tree :-(
+			    card_layout.show(details_pane, BLANK); // Show a blank panel.
 			    
-			    new_node = model.add(parent, current_element, GEMSNode.ELEMENT);
-			    TreePath new_node_path = new TreePath(new_node.getPath());
-
-			    value_model.nodeChanged((TreeNode)current_node); //trial!
-			    value_model.nodeStructureChanged((TreeNode)current_node);
-			    mds_tree.repaint();
-
-			    //mds_tree.setSelectionPath(new_node_path);
-			    //Could now select the new element, but for now will just clean up ;-)
-			    // Disable/enable controls given we had an element selected, but no longer do.
-			    //card_layout.show(details_pane, BLANK); // Show a blank panel.
-			    //ignore = false;
-			    
+			    //finish up
 			    currentSet.setSetChanged(true);
 			    atLeastOneSetChanged = true;
@@ -3037,5 +2191,5 @@
     /**
        Class to handle DELETE key presses on the tree.
-       The class then fires the appropriate event to remove that subelement/element/set.
+       The class then fires the appropriate event to remove that element/set.
        Attributes in the table are handled directly by the RemoveAttributeActionListener
 
@@ -3086,29 +2240,15 @@
 	    if(cont)
 		{
-		    
 		    //Check to see if pressed on Set or Element.
 		    TreePath selPath = mds_tree.getSelectionPath();
 		    GEMSNode t = (GEMSNode)selPath.getLastPathComponent();
 		    
-		    if(t.type == T_SUBELEMENT) //Remove the subelement
+		    if(t.type == T_ELEMENT) //Remove the element
 			{
-			    RemoveSubelementActionListener removeSubelement = new RemoveSubelementActionListener();
-			    removeSubelement.actionPerformed((ActionEvent)null);
-			}
-		    else if(t.type == T_ELEMENT) //Remove the element
-			{
-			    //System.err.println("element");
 			    RemoveElementActionListener removeElement = new RemoveElementActionListener();
 			    removeElement.actionPerformed((ActionEvent)null);
 			}
-		    
-		    else if(t.type == T_ROOT)
-			{
-			    //Do nothing
-			    System.err.println("Tree type of ROOT: this should not happen!");
-			}
 		    else if(t.type == T_SET) //Remove the whole set
 			{
-			    //System.err.println("set");
 			    RemoveSetActionListener removeSet = new RemoveSetActionListener();
 			    removeSet.actionPerformed((ActionEvent)null);
@@ -3118,7 +2258,4 @@
     }
     
-
-   
-
 
     private class RemoveSetActionListener
@@ -3151,30 +2288,8 @@
 		    // Clear selection
 		    mds_tree.clearSelection();
-		    model.remove(current_set.toString(), GEMSNode.SET);
+		    model.remove(current_node);
 		    card_layout.show(details_pane, BLANK); //Show a blank panel.
 		    ignore = false;
  
-		}
-	    }
-	}
-    }
-
-    /** This class will remove the currently selected metadata or profile value when any registered control is actioned. Note that removing a value acts differently from the other removes in that if you remove a value which is still assigned somewhere the values are restored next time said assignment is viewed. This turned out far easier and reasonable to code than attempting to remove all remaining values when you delete its reference in the GValueModel. */
-    private class RemoveValueActionListener
-	implements ActionListener {
-	/** Any implementation of ActionListener must include this method so that we can be informed when an action as occured on our registered component, allowing us to
-	 * @param event An <strong>ActionEvent</strong> containing information about the event.
-	 */
-	public void actionPerformed(ActionEvent event) {
-	    if(current_value_node != null) {	
-		int result = JOptionPane.showOptionDialog(self, Dictionary.get("GEMS.Confirm_Removal", Dictionary.get("GEMS.Value")), Dictionary.get("GEMS.Confirm_Removal_Title"), JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE, null, dialog_options, dialog_options[0]);
-		// Remove the current selected value
-		if(result == 0) {
-		    ignore = true;
-		    ignore = false; //What the heck?? --Matthew
-                    
-                    //does this ever get called?
-                    System.out.println("\nGEMS.RemovevalueActionListener called");
-                    atLeastOneSetChanged = true;
 		}
 	    }
@@ -3247,28 +2362,5 @@
 		{
 		    current_attribute = table.getSelectedRow();
-		    /*
-		    if((current_attribute = table.getSelectedRow()) != -1)
-			{		    
-			}
-		    else
-			{
-			    current_attribute = -1;
-			}
-		    */
-		}
-	}
-    }
-    
-    private class ElementValuesTreeSelectionListener
-	implements TreeSelectionListener {
-	public void valueChanged(TreeSelectionEvent event) {
-	    if(element_values.getSelectionCount() > 0) {
-		// Retrieve the selected value node.
-		TreePath selected_path = element_values.getSelectionPath();
-		current_value_node = (GValueNode) selected_path.getLastPathComponent();
-	    }
-	    else {
-		current_value_node = null;
-	    }
+		}
 	}
     }
@@ -3278,7 +2370,5 @@
 	public void valueChanged(TreeSelectionEvent event) {
 	    if(!ignore) {
-		GValueModel value_model = null;
 		// Clear all variables based on previous tree selection
-		current_collection_file = null;
 		current_element = null;
 		current_set = null;
@@ -3291,34 +2381,4 @@
 		current_attribute_type = current_node.getType();
 		switch(current_attribute_type) {
-		case GEMSNode.COLLECTION:
-		    current_collection_file = (String) current_node.getUserObject();
-		    atm = current_node.getModel();
-		    if(atm == null) {
-			attributes = new TreeSet();
-      
-			atm = new AttributeTableModel(attributes, Dictionary.get("GEMS.Source"), Dictionary.get("GEMS.Target"), Dictionary.get("GEMS.Ignore"));
-		    }
-		    profile_attributes.setModel(atm);
-		    atm.setScrollPane(profile_attributes_scroll);
-		    atm.setTable(profile_attributes);
-
-		    card_layout.show(details_pane, PROFILE);
-		    break;
-
-		case GEMSNode.SUBELEMENT:
-		    current_subelement = current_node.getSubelement();
-		    
-		    atm = current_node.getModel();
-		    if(atm == null) {
-			atm = new AttributeTableModel(current_subelement.getAttributes(), Dictionary.get("GEMS.Name"), Dictionary.get("GEMS.Language_Code"), Dictionary.get("GEMS.Value"), "");
-		    }
-
-		    subelement_attributes.setModel(atm);
-		    atm.setScrollPane(subelement_attributes_scroll);
-		    atm.setTable(subelement_attributes);
-		    //System.err.println("atm is: " + atm); //debug
-
-		    card_layout.show(details_pane, SUBELEMENT); 
-		    break;
 
 		case GEMSNode.ELEMENT:
@@ -3333,16 +2393,4 @@
 		    atm.setTable(element_attributes);
 
-		    // Be careful not to add the keep_root_expanded_listener over and over!
-		    value_model = msm.getValueTree(current_element);
-		    if(value_model != null) {
-			value_model.removeTreeModelListener(keep_root_expanded_listener); // Remove it if its already there
-			value_model.addTreeModelListener(keep_root_expanded_listener); // Then add again.
-			element_values.setModel(value_model);
-			element_values_layout.show(element_values_pane, VALUES);
-		    }
-		    else {
-			//this shouldn't happen!
-			element_values_layout.show(element_values_pane, BLANK);
-		    }
 		    card_layout.show(details_pane, ELEMENT);
 		    break;
@@ -3371,5 +2419,4 @@
 		    attributes = null;
 		    break;
-		case GEMSNode.PROFILER:
 
 		default:
@@ -3395,35 +2442,27 @@
 
     //PopupListener is our main manager for all right-click popups
-  class PopupListener extends MouseAdapter implements ActionListener{
-      JPopupMenu setPopup;
-      JPopupMenu subelementPopup;
-      JPopupMenu elementPopup;
-      JPopupMenu attributePopup;
-      //all of our popup menu items EVER!
-      JMenuItem menuAddSet;
-      JMenuItem menuRenameSet;
-      JMenuItem menuAddElement;
-      JMenuItem menuAddAttributeSet;
-
-      JMenuItem menuRenameSubelement;
-      JMenuItem menuDeleteSubelement;
-      JMenuItem menuAddAttributeSubelement;
-      JMenuItem menuRenameElement;
-      
-      JMenuItem menuDeleteElement;
-      JMenuItem menuAddAttributeElement;
-      JMenuItem menuAddSubelement;
-      JMenuItem menuAddSubelementCopy;
-      
-      JMenuItem menuEditValue;
-      JMenuItem menuDeleteAttribute;
-      JMenuItem menuAddAttributeAttribute;
-      
-      JMenuItem menuRemoveSet;
-      
+    class PopupListener extends MouseAdapter implements ActionListener{
+	JPopupMenu setPopup;
+	JPopupMenu elementPopup;
+	JPopupMenu attributePopup;
+
+	//all of our popup menu items EVER!
+	JMenuItem menuAddAttributeSet;
+	JMenuItem menuAddElement;
+	JMenuItem menuRenameSet;
+	JMenuItem menuRemoveSet;
+
+	JMenuItem menuAddAttributeElement;
+	JMenuItem menuAddSubelement;
+	JMenuItem menuRenameElement;
+	JMenuItem menuDeleteElement;
+
+	JMenuItem menuAddAttributeAttribute;
+	JMenuItem menuEditValue;
+	JMenuItem menuDeleteAttribute;
+	
         GEMS GEMSRef = null;
         PopupListener(GEMS g) {
 	    setPopup = new JPopupMenu();
-	    subelementPopup = new JPopupMenu();
 	    elementPopup = new JPopupMenu();
 	    attributePopup = new JPopupMenu();
@@ -3431,109 +2470,63 @@
             //reference to our parent(GEMS), because some of the actionlisteners would not
             //work unless they were declared in GEMS, and I need a way to reference GEMS
-            
 	    GEMSRef = g;
 	    
-	    //create the MenuItems
-	    
-	    //set related popups
-	    menuAddSet = new JMenuItem();
-            
+	    //Create the menu items
+	    menuAddAttributeSet = new JMenuItem();
+	    Dictionary.setText(menuAddAttributeSet, "GEMS.Popup.menuAddAttribute");
+	    menuAddElement =new JMenuItem();
+	    Dictionary.setText(menuAddElement,"GEMS.Popup.menuAddElement");
 	    menuRenameSet = new JMenuItem();
 	    Dictionary.setText(menuRenameSet,"GEMS.Popup.menuRenameSet");
-	    
-	    menuAddElement =new JMenuItem();
-	   // Dictionary.setText(menuAddElement,"GEMS.Popup.menuAddElement");
-	    Dictionary.setText(menuAddElement,"GEMS.Add_Element_Tooltip");
-	    
-	    menuAddAttributeSet = new JMenuItem();
-	   // Dictionary.setText(menuAddAttributeSet, "GEMS.Popup.menuAddAttribute");
-	    Dictionary.setText(menuAddAttributeSet, "GEMS.Add_Attribute_Tooltip");
-	    
-            
             menuRemoveSet = new JMenuItem();
-	   Dictionary.setText(menuRemoveSet,"GEMS.Remove_Set_Tooltip");
-	    
-            //subelement related GEMS.Popups
-            menuRenameSubelement = new JMenuItem();
-            Dictionary.setText(menuRenameSubelement,"GEMS.Popup.menuRenameSubelement");
-            
-            menuDeleteSubelement=new JMenuItem();
-            Dictionary.setText(menuDeleteSubelement,"GEMS.Popup.menuRemoveSubelement");
-            
-            menuAddAttributeSubelement=new JMenuItem();
-           // Dictionary.setText(menuAddAttributeSubelement,"GEMS.Popup.menuAddAttribute");
-             Dictionary.setText(menuAddAttributeSubelement,"GEMS.Add_Attribute_Tooltip");
-            
-            //element related GEMS.Popups
+	    Dictionary.setText(menuRemoveSet, "GEMS.Popup.menuRemoveSet");
+            
+            menuAddAttributeElement=new JMenuItem();
+            Dictionary.setText(menuAddAttributeElement,"GEMS.Popup.menuAddAttribute");
+	    menuAddSubelement=new JMenuItem();
+            Dictionary.setText(menuAddSubelement,"GEMS.Popup.menuAddSubelement");
             menuRenameElement=new JMenuItem();
             Dictionary.setText(menuRenameElement,"GEMS.Popup.menuRenameElement");
-	    // Dictionary.setText(menuRenameElement,"GEMS.Rename_Element_Tooltip");
-            
             menuDeleteElement=new JMenuItem();
-           // Dictionary.setText(menuDeleteElement,"GEMS.Popup.menuRemoveElement");
-            Dictionary.setText(menuDeleteElement,"GEMS.Remove_Element_Tooltip");
-            
-            menuAddAttributeElement=new JMenuItem();
-            //Dictionary.setText(menuAddAttributeElement,"GEMS.Popup.menuAddAttribute");
-            Dictionary.setText(menuAddAttributeElement,"GEMS.Add_Attribute_Tooltip");
-            
-            menuAddSubelement=new JMenuItem();
-            Dictionary.setText(menuAddSubelement,"GEMS.Popup.menuAddSubelement");
-             //Dictionary.setText(menuAddSubelement,"GEMS.Add_Subelement");
-	    menuAddSubelementCopy = new JMenuItem(); //A copy of menuAddSubelement
-	    Dictionary.setText(menuAddSubelementCopy, "GEMS.Popup.menuAddSubelement");
-        
-            //attribute related GEMS.Popups
+	    Dictionary.setText(menuDeleteElement,"GEMS.Popup.menuRemoveElement");
+
+	    menuAddAttributeAttribute=new JMenuItem();
+	    Dictionary.setText(menuAddAttributeAttribute,"GEMS.Popup.menuAddAttribute");
             menuEditValue=new JMenuItem();
-            //Dictionary.setText(menuEditValue,"GEMS.Popup.menuEditValue");
-            Dictionary.setText(menuEditValue,"GEMS.Edit_Value_Tooltip");
-            
+            Dictionary.setText(menuEditValue,"GEMS.Popup.menuEditValue");
             menuDeleteAttribute=new JMenuItem();
-           // Dictionary.setText(menuDeleteAttribute,"GEMS.Popup.menuRemoveAttribute");
-            Dictionary.setText(menuDeleteAttribute,"GEMS.Remove_Attribute_Tooltip");
-            
-            menuAddAttributeAttribute=new JMenuItem();
-           // Dictionary.setText(menuAddAttributeAttribute,"GEMS.Popup.menuAddAttribute");
-             Dictionary.setText(menuAddAttributeAttribute,"GEMS.Add_Attribute_Tooltip");
+	    Dictionary.setText(menuDeleteAttribute,"GEMS.Popup.menuRemoveAttribute");
              
-             //start Associate the menu items with the appropriate popups:
-	     setPopup.add(menuAddAttributeSet);
-	     setPopup.add(menuAddElement);
-             setPopup.add(menuRenameSet);
-	     setPopup.add(menuRemoveSet);
-            
-	     elementPopup.add(menuAddAttributeElement);
-	     elementPopup.add(menuAddSubelement);
-             elementPopup.add(menuRenameElement);
-             elementPopup.add(menuDeleteElement);
-             
-	     subelementPopup.add(menuAddAttributeSubelement);
-	     //subelementPopup.add(menuAddSubelementCopy);
-             subelementPopup.add(menuRenameSubelement);
-             subelementPopup.add(menuDeleteSubelement);
-            
-	     attributePopup.add(menuAddAttributeAttribute);
-             attributePopup.add(menuEditValue);
-             attributePopup.add(menuDeleteAttribute);
-             //end Associate the menu items with the appropriate popups:
-             
-             menuRemoveSet.addActionListener(new RemoveSetActionListener());
-             menuAddElement.addActionListener(new AddElementActionListener());
-             menuAddAttributeSet.addActionListener(new AddOrEditAttributeActionListener());
-             menuRenameSubelement.addActionListener(new RenameSubelementActionListener());
-             menuDeleteSubelement.addActionListener(new RemoveSubelementActionListener());
-             menuAddAttributeSubelement.addActionListener(new AddOrEditAttributeActionListener());
-             
-	     menuRenameSet.addActionListener(new RenameSetActionListener());
-             menuRenameElement.addActionListener(new RenameElementActionListener());
-             menuDeleteElement.addActionListener(new RemoveElementActionListener());
-             menuAddAttributeElement.addActionListener(new AddOrEditAttributeActionListener());
-             menuAddSubelement.addActionListener(new AddSubelementActionListener());
-	     menuAddSubelementCopy.addActionListener(new AddSubelementActionListener());
-             menuEditValue.addActionListener(new AddOrEditAttributeActionListener());
-             menuDeleteAttribute.addActionListener(new RemoveAttributeActionListener());
-             menuAddAttributeAttribute.addActionListener(new AddOrEditAttributeActionListener());
-            
+	    //Associate the menu items with the appropriate popups:
+	    setPopup.add(menuAddAttributeSet);
+	    setPopup.add(menuAddElement);
+	    setPopup.add(menuRenameSet);
+	    setPopup.add(menuRemoveSet);
+            
+	    elementPopup.add(menuAddAttributeElement);
+	    elementPopup.add(menuAddSubelement);
+	    elementPopup.add(menuRenameElement);
+	    elementPopup.add(menuDeleteElement);
+            
+	    attributePopup.add(menuAddAttributeAttribute);
+	    attributePopup.add(menuEditValue);
+	    attributePopup.add(menuDeleteAttribute);
+	    
+	    //Add appropriate action listeners to the menu items.
+	    menuAddAttributeSet.addActionListener(new AddOrEditAttributeActionListener());
+	    menuAddElement.addActionListener(new AddElementActionListener());
+	    menuRenameSet.addActionListener(new RenameSetActionListener());
+	    menuRemoveSet.addActionListener(new RemoveSetActionListener());
+	    
+	    menuAddAttributeElement.addActionListener(new AddOrEditAttributeActionListener());
+	    menuAddSubelement.addActionListener(new AddSubelementActionListener());
+	    menuRenameElement.addActionListener(new RenameElementActionListener());
+	    menuDeleteElement.addActionListener(new RemoveElementActionListener());
+	   
+	    menuEditValue.addActionListener(new AddOrEditAttributeActionListener());
+	    menuDeleteAttribute.addActionListener(new RemoveAttributeActionListener());
+	    menuAddAttributeAttribute.addActionListener(new AddOrEditAttributeActionListener());            
         }
+
         public void mouseClicked(MouseEvent e) {
             maybeShowPopup(e);
@@ -3541,6 +2534,5 @@
         public void mousePressed(MouseEvent e){
         maybeShowPopup(e);
-       
-   }
+	}
         public void mouseReleased(MouseEvent e) {
             maybeShowPopup(e);
@@ -3548,84 +2540,44 @@
 
         private void maybeShowPopup(MouseEvent e) {
-           
-         int selRow = mds_tree.getRowForLocation(e.getX(), e.getY());
-	 TreePath selPath = mds_tree.getPathForLocation(e.getX(), e.getY());
-	 Point p = null;
+	    TreePath selPath = mds_tree.getPathForLocation(e.getX(), e.getY());
+	    Point p = null;
             if (e.isPopupTrigger()) {
-               
-             if(e.getSource() == mds_tree) {
-                try {
-                
-                    GEMSNode t = (GEMSNode)selPath.getLastPathComponent();
-		    
-		    mds_tree.setSelectionPath(selPath); //Select node right-clicked on
-		    
-		    if(t.type == T_ELEMENT){
+		
+		if(e.getSource() == mds_tree) {
+		    try {
+			GEMSNode t = (GEMSNode)selPath.getLastPathComponent();
 			
-			elementPopup.show(e.getComponent(),
-					  e.getX(), e.getY());
+			mds_tree.setSelectionPath(selPath); //Select node right-clicked on
+			
+			if(t.type == T_ELEMENT){
+			    elementPopup.show(e.getComponent(), e.getX(), e.getY());
+			}
+			else if(t.type == T_SET){
+			    setPopup.show(e.getComponent(), e.getX(), e.getY());
+			}
 		    }
-
-		    else if(t.type == T_SUBELEMENT)
-			{
-			    subelementPopup.show(e.getComponent(), e.getX(), e.getY());
-			}
-
-		    else if(t.type == T_ROOT){
-			
-			setPopup.show(e.getComponent(),
-				      e.getX(), e.getY());
+		    catch(Exception NullPointerException) {
+			//Right-clicked in tree area, but no item to select. Do nothing.
 		    }
-		    else if(t.type == T_SET){
-			
-			setPopup.show(e.getComponent(),
-				      e.getX(), e.getY());
-		    }
-                }
-		catch(Exception NullPointerException) {
-		    //Right-clicked in tree area, but no item to select. Do nothing.
-		}
-
-                finally {
-                    ;
-                    
-                }
-                
-                    
-             }
-             else if(e.getSource() == set_attributes){ //When right-click on table of set attributes
-		 
-		 //Select the table row that was right-clicked on.
-		 p = e.getPoint();
-		 set_attributes.changeSelection(set_attributes.rowAtPoint(p), set_attributes.columnAtPoint(p), false, false);
-
-                 attributePopup.show(e.getComponent(),
-                           e.getX(), e.getY());  
-             }
-             else if(e.getSource() == element_attributes)  { //When right-click on table of element attributes
-                
-		 //Select the table row that was right-clicked on.
-		 p = e.getPoint();
-		 element_attributes.changeSelection(element_attributes.rowAtPoint(p), element_attributes.columnAtPoint(p), false, false);
-
-		 attributePopup.show(e.getComponent(),
-                           e.getX(), e.getY());
-             }
-	     else if(e.getSource() == subelement_attributes)  { //When right-click on table of subelement attributes
-		 
-		 //Select the table row that was right-clicked on.
-		 p = e.getPoint();
-		 subelement_attributes.changeSelection(subelement_attributes.rowAtPoint(p), subelement_attributes.columnAtPoint(p), false, false);
-
-		 attributePopup.show(e.getComponent(),
-				     e.getX(), e.getY());
-             }
+		}
+		else if(e.getSource() == set_attributes){ //When right-click on table of set attributes
+		    //Select the table row that was right-clicked on.
+		    p = e.getPoint();
+		    set_attributes.changeSelection(set_attributes.rowAtPoint(p), set_attributes.columnAtPoint(p), false, false);
+		    attributePopup.show(e.getComponent(), e.getX(), e.getY());  
+		}
+		else if(e.getSource() == element_attributes)  { //When right-click on table of element attributes
+		    //Select the table row that was right-clicked on.
+		    p = e.getPoint();
+		    element_attributes.changeSelection(element_attributes.rowAtPoint(p), element_attributes.columnAtPoint(p), false, false);
+		    attributePopup.show(e.getComponent(), e.getX(), e.getY());
+		}
             }  
         }
-     
-        public void actionPerformed(ActionEvent e) {
-	    //This should never happen!!
-            System.out.println("NO way hose");
-        }
+      
+      public void actionPerformed(ActionEvent e) {
+	  //This should never happen!!
+	  System.err.println("Error: actionPerformed was called in class PopupListener. This should never happen!");
+      }
     }
   
